/******************* (C) COPYRIGHT 2009~2021 holychip **************************
* File Name          : HolyChip_Level_Touch_Lib.c
********************************************************************************


*******************************************************************************/
#include "HC89F3541.h"
#include "HolyChip_Level_Touch_Lib_V1.00\HolyChip_Level_Touch_Lib.h"
#include "HC89F3xx1_GeneralKey_Touch_Lib_V1.04\HC89F3xx1_GeneralKey_Touch_Lib.h"
#include "HC89F3xx1_GeneralKey_Touch_Lib_V1.04\HC89F3xx1_GeneralKey_Touch_Lib_CFG.h"
#include "intrins.h"
//===============================================================================


#define LEVEL_OPENCNT  6	 //ˮͨ

#define LEVEL_COLLECT_CNT 10 //У׼ֵɼ(˲)

#define Effect_Data 9 //Һλ(ˮֵ-ˮֵ)*Effect_Data/10

unsigned char code guc_LevelOpenMask[LEVEL_OPENCNT] = {4,6,8,10,13,15};	//ˮͨţˮͨˮλ ˮλ---->ˮλ



unsigned char xdata Effect_Conditions = Effect_Data;

unsigned int xdata Level_Key_Flag = 0;//ˮλӦ־λ

unsigned char xdata guc_Positioning[LEVEL_OPENCNT] = {0};//ˮͨӦRawDataеλ

unsigned int xdata Empty_Value[LEVEL_OPENCNT] = {0};//ˮУ׼ֵ
unsigned int xdata Full_Value[LEVEL_OPENCNT] = {0};//ˮУ׼ֵ


extern uc16	CODE_TK_CH_MASK;	 //ʹõͨ
extern uc8 	CODE_TK_CH_MAX;		 //ͨ(ݷװѡ)
extern ux16 XDATA_RawDataBuf[];  //RawData

//===============================================================================
#define HexadecimalToBinary(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p)	\
(																\
	(a<<15)+(b<<14)+(c<<13)+(d<<12)+							\
	(e<<11)+(f<<10)+(g<<9)+(h<<8)+								\
	(i<<7)+(j<<6)+(k<<5)+(l<<4)+								\
	(m<<3)+(n<<2)+(o<<1)+(p<<0)									\
)

#define TKBIN HexadecimalToBinary
#define HCTouchLib_OPENED_TK_AMOUNT \
((HCTouchLib_TK_CH_MASK>> 0 & 0x01L)+(HCTouchLib_TK_CH_MASK>> 1 & 0x01L)+(HCTouchLib_TK_CH_MASK>> 2 & 0x01L)+(HCTouchLib_TK_CH_MASK>> 3 & 0x01L)+\
 (HCTouchLib_TK_CH_MASK>> 4 & 0x01L)+(HCTouchLib_TK_CH_MASK>> 5 & 0x01L)+(HCTouchLib_TK_CH_MASK>> 6 & 0x01L)+(HCTouchLib_TK_CH_MASK>> 7 & 0x01L)+\
 (HCTouchLib_TK_CH_MASK>> 8 & 0x01L)+(HCTouchLib_TK_CH_MASK>> 9 & 0x01L)+(HCTouchLib_TK_CH_MASK>>10 & 0x01L)+(HCTouchLib_TK_CH_MASK>>11 & 0x01L)+\
 (HCTouchLib_TK_CH_MASK>>12 & 0x01L)+(HCTouchLib_TK_CH_MASK>>13 & 0x01L)+(HCTouchLib_TK_CH_MASK>>14 & 0x01L)+(HCTouchLib_TK_CH_MASK>>15 & 0x01L))


//===================================================================================================
void LEVEL_INIT()//ˮλʼ(ҵˮλͨӦRawDataеλ)
{
	ux8 i=0;
	ux8 j=0;
	ux8 k=0;
	ux8 TK_Number = 0;
	ux16 PassageWay = 0;
	ux16 TK_OpenMask[HCTouchLib_OPENED_TK_AMOUNT] = {0};
	PassageWay = (uint)CODE_TK_CH_MASK; 
	
	for(i = 0; i < CODE_TK_CH_MAX; i++)
	{
		if(PassageWay & ((uint)0x01 << i))
		{
			TK_OpenMask[j] = i;//ҵĴͨ
			j++;
		}
	}
	TK_Number = j;
	

	for(i = 0; i < LEVEL_OPENCNT; i++)
	{
		for(j = 0; j < TK_Number; j++)
		{
			if(guc_LevelOpenMask[i] == TK_OpenMask[j])
			{
				guc_Positioning[k] = j;
			
				k++;
			}			
		}
	}
}
//===================================================================================================
//===================================================================================================
void LEVEL_CALIBRATION(char Mode_Flag)
{
	u8 i = 0;
	u8 guc_Collect_Cnt = LEVEL_COLLECT_CNT;
	unsigned long int xdata Level_Value[LEVEL_OPENCNT] = {0};//ɼNۼֵ
	
	Scan_Pause();
	_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();
	Scan_Continue();
	
	while(guc_Collect_Cnt)
	{
		if(OneCycleScanDone)
		{
			for(i=0;i<LEVEL_OPENCNT;i++)
			{
				Level_Value[i] += XDATA_RawDataBuf[guc_Positioning[i]];
			}
			OneCycleScanDone = 0;
			guc_Collect_Cnt--;
			Scan_Continue();
		}	
	}
	
	switch(Mode_Flag)
	{
			case 0:
			{
				for(i=0;i<LEVEL_OPENCNT;i++)
				{
					Empty_Value[i] =  Level_Value[i]/LEVEL_COLLECT_CNT;
				}
			}break;
			case 1:
		    {
				for(i=0;i<LEVEL_OPENCNT;i++)
				{
					Full_Value[i] =  Level_Value[i]/LEVEL_COLLECT_CNT;
				}
			}break;
		
	}
}



void LEVEL_HANDLE()//ˮλ
{
	u8 i;
	for(i=0;i<LEVEL_OPENCNT;i++)
	{
		CAPACITY(i);
	}
}

void CAPACITY(u8 i)
{

	ux16 Mask = 0;
	sx16 Differ_Data = 0;
	sx16 Real_Value = 0;
	
	Mask = ((uint)0x01 << guc_LevelOpenMask[i]);
	
	Differ_Data = (Full_Value[i] - Empty_Value[i])*Effect_Conditions/10;//ֵ
	
	Real_Value = (XDATA_RawDataBuf[guc_Positioning[i]] - Empty_Value[i]);//ʵʱɼֵ

	if(Real_Value > Differ_Data)//
	{
	
			if(i>0)
			{
				if(Level_Key_Flag & ((uint)0x01 << guc_LevelOpenMask[i-1]))
				{
				  Level_Key_Flag |= Mask;
					
				}
				else
				{
				  Level_Key_Flag &= ~Mask;
					
				}
			}
			else
			{
				Level_Key_Flag |= Mask;
				
			}
		
	}
	else
	{

		  Level_Key_Flag &= ~Mask;
		
	}	
}



